#if ! defined _XTV_LIB_PREFERENCES_H
#define _XTV_LIB_PREFERENCES_H

//
//  Preferences.h
//
//  Copyright (c) 2001 A.Thiede.
//
//
// based on:
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.


#if defined __cplusplus
extern "C" {
#endif

int  GetPrivateProfileInt   ( const char * section, const char * var, int          _default                          );
int  GetPrivateProfileString( const char * section, const char * var, const char * _default, char * result, int size );

void WritePrivateProfileInt   ( const char * section, const char * var,       int    value );
void WritePrivateProfileString( const char * section, const char * var, const char * value );

void RemovePrivateProfileString( const char * section, const char * var );

const char * GetApplicationDirectory();


#if defined __cplusplus
}
#endif

#endif /* _XTV_LIB_PREFERENCES_H */
